/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1, unsigned int i1, rtx_code i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != i3)
    return -1;
  return 0;
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !rx_source_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 16
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x3, 1);
  switch (GET_CODE (x8))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x8;
      if (!rx_source_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case ZERO_EXTEND:
      res = pattern15 (x8);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case SIGN_EXTEND:
      res = pattern15 (x8);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_MODE (x4) != E_CCmode
      || GET_MODE (x2) != E_CCmode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!rx_restricted_mem_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_QImode:
      if (!rx_restricted_mem_operand (operands[1], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  if (!rx_constshift_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x3, 2);
  operands[2] = x6;
  if (!rx_constshift_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  if (!label_ref_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 3
      || GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (pattern24 (x3, 
UNSPEC, 
CONST) != 0)
    return -1;
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  if (XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 13
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 0
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != RETURN
      || GET_MODE (x3) != E_SImode)
    return -1;
  x8 = XVECEXP (x5, 0, 0);
  operands[0] = x8;
  if (!const_int_operand (operands[0], E_VOIDmode))
    return -1;
  return 13; /* deallocate_and_return */
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (!register_operand (x3, E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case PC:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      operands[0] = x3;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      return 11; /* tablejump */

    case ZERO_EXTRACT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern9 (x5, 
16, 
CLOBBER, 
E_CCmode) != 0)
        return -1;
      x9 = XEXP (x4, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x4, 2);
      operands[1] = x10;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      operands[2] = x3;
      return 146; /* rx_insv_reg */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 7
      || XINT (x2, 1) != 47
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 1
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 3
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x2, 0, 4);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 4
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x2, 0, 5);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 5
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XVECEXP (x2, 0, 6);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 6
      || GET_MODE (x9) != E_SImode
      || pattern51 (x1, 
2) != 0)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 3
      || GET_MODE (x11) != E_SImode
      || !
#line 2712 "../../gcc/config/rx/rx.md"
(rx_allow_string_insns))
    return -1;
  return 167; /* rmpa */
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return NULL;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (rx_restricted_mem_operand (operands[1], E_HImode))
        {
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern39 (x4))
            {
            case 0:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 0);
              if (rtx_equal_p (x7, operands[0]))
                {
                  x8 = XEXP (x6, 1);
                  if (rtx_equal_p (x8, operands[2])
                      && 
#line 1798 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_7 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (rtx_equal_p (x7, operands[2]))
                {
                  x8 = XEXP (x6, 1);
                  if (rtx_equal_p (x8, operands[0])
                      && 
#line 1812 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_23 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case 1:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 0);
              if (rtx_equal_p (x7, operands[0]))
                {
                  x8 = XEXP (x6, 1);
                  if (rtx_equal_p (x8, operands[2])
                      && 
#line 1798 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_8 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (rtx_equal_p (x7, operands[2]))
                {
                  x8 = XEXP (x6, 1);
                  if (rtx_equal_p (x8, operands[0])
                      && 
#line 1812 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_24 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case 2:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 0);
              if (rtx_equal_p (x7, operands[0]))
                {
                  x8 = XEXP (x6, 1);
                  if (rtx_equal_p (x8, operands[2])
                      && 
#line 1798 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_9 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (rtx_equal_p (x7, operands[2]))
                {
                  x8 = XEXP (x6, 1);
                  if (rtx_equal_p (x8, operands[0])
                      && 
#line 1812 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_25 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case 3:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 0);
              if (rtx_equal_p (x7, operands[0]))
                {
                  x8 = XEXP (x6, 1);
                  if (rtx_equal_p (x8, operands[2])
                      && 
#line 1798 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_10 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (rtx_equal_p (x7, operands[2]))
                {
                  x8 = XEXP (x6, 1);
                  if (rtx_equal_p (x8, operands[0])
                      && 
#line 1812 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_26 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case 4:
              if (
#line 1826 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_38 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              if (
#line 1826 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_39 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 6:
              if (
#line 1826 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_40 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 7:
              x9 = XEXP (x4, 1);
              x10 = XEXP (x9, 0);
              if (rtx_equal_p (x10, operands[0]))
                {
                  x11 = XEXP (x9, 1);
                  if (rtx_equal_p (x11, operands[2])
                      && 
#line 1839 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_50 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (rtx_equal_p (x10, operands[2]))
                {
                  x11 = XEXP (x9, 1);
                  if (rtx_equal_p (x11, operands[0])
                      && 
#line 1851 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_62 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case 8:
              x9 = XEXP (x4, 1);
              x10 = XEXP (x9, 0);
              if (rtx_equal_p (x10, operands[0]))
                {
                  x11 = XEXP (x9, 1);
                  if (rtx_equal_p (x11, operands[2])
                      && 
#line 1839 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_51 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (rtx_equal_p (x10, operands[2]))
                {
                  x11 = XEXP (x9, 1);
                  if (rtx_equal_p (x11, operands[0])
                      && 
#line 1851 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_63 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case 9:
              x9 = XEXP (x4, 1);
              x10 = XEXP (x9, 0);
              if (rtx_equal_p (x10, operands[0]))
                {
                  x11 = XEXP (x9, 1);
                  if (rtx_equal_p (x11, operands[2])
                      && 
#line 1839 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_52 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (rtx_equal_p (x10, operands[2]))
                {
                  x11 = XEXP (x9, 1);
                  if (rtx_equal_p (x11, operands[0])
                      && 
#line 1851 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_64 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case 10:
              if (
#line 1895 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_72 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[1], E_HImode))
        return NULL;
      x4 = PATTERN (peep2_next_insn (1));
      switch (pattern41 (x4, 
E_HImode))
        {
        case 0:
          if (!
#line 1911 "../../gcc/config/rx/rx.md"
(REGNO (operands[0]) == REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[2])
       || peep2_regno_dead_p (2, REGNO (operands[0])))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_75 (insn, operands);

        case 1:
          if (!
#line 1926 "../../gcc/config/rx/rx.md"
(REGNO (operands[0]) == REGNO (operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_78 (insn, operands);

        default:
          return NULL;
        }

    case E_QImode:
      if (rx_restricted_mem_operand (operands[1], E_QImode))
        {
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern39 (x4))
            {
            case 0:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 0);
              if (rtx_equal_p (x7, operands[0]))
                {
                  x8 = XEXP (x6, 1);
                  if (rtx_equal_p (x8, operands[2])
                      && 
#line 1798 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_15 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (rtx_equal_p (x7, operands[2]))
                {
                  x8 = XEXP (x6, 1);
                  if (rtx_equal_p (x8, operands[0])
                      && 
#line 1812 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_31 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case 1:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 0);
              if (rtx_equal_p (x7, operands[0]))
                {
                  x8 = XEXP (x6, 1);
                  if (rtx_equal_p (x8, operands[2])
                      && 
#line 1798 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_16 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (rtx_equal_p (x7, operands[2]))
                {
                  x8 = XEXP (x6, 1);
                  if (rtx_equal_p (x8, operands[0])
                      && 
#line 1812 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_32 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case 2:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 0);
              if (rtx_equal_p (x7, operands[0]))
                {
                  x8 = XEXP (x6, 1);
                  if (rtx_equal_p (x8, operands[2])
                      && 
#line 1798 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_17 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (rtx_equal_p (x7, operands[2]))
                {
                  x8 = XEXP (x6, 1);
                  if (rtx_equal_p (x8, operands[0])
                      && 
#line 1812 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_33 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case 3:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 0);
              if (rtx_equal_p (x7, operands[0]))
                {
                  x8 = XEXP (x6, 1);
                  if (rtx_equal_p (x8, operands[2])
                      && 
#line 1798 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_18 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (rtx_equal_p (x7, operands[2]))
                {
                  x8 = XEXP (x6, 1);
                  if (rtx_equal_p (x8, operands[0])
                      && 
#line 1812 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_34 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case 4:
              if (
#line 1826 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_44 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              if (
#line 1826 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_45 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 6:
              if (
#line 1826 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_46 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 7:
              x9 = XEXP (x4, 1);
              x10 = XEXP (x9, 0);
              if (rtx_equal_p (x10, operands[0]))
                {
                  x11 = XEXP (x9, 1);
                  if (rtx_equal_p (x11, operands[2])
                      && 
#line 1839 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_56 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (rtx_equal_p (x10, operands[2]))
                {
                  x11 = XEXP (x9, 1);
                  if (rtx_equal_p (x11, operands[0])
                      && 
#line 1851 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_68 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case 8:
              x9 = XEXP (x4, 1);
              x10 = XEXP (x9, 0);
              if (rtx_equal_p (x10, operands[0]))
                {
                  x11 = XEXP (x9, 1);
                  if (rtx_equal_p (x11, operands[2])
                      && 
#line 1839 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_57 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (rtx_equal_p (x10, operands[2]))
                {
                  x11 = XEXP (x9, 1);
                  if (rtx_equal_p (x11, operands[0])
                      && 
#line 1851 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_69 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case 9:
              x9 = XEXP (x4, 1);
              x10 = XEXP (x9, 0);
              if (rtx_equal_p (x10, operands[0]))
                {
                  x11 = XEXP (x9, 1);
                  if (rtx_equal_p (x11, operands[2])
                      && 
#line 1839 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_58 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (rtx_equal_p (x10, operands[2]))
                {
                  x11 = XEXP (x9, 1);
                  if (rtx_equal_p (x11, operands[0])
                      && 
#line 1851 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_70 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case 10:
              if (
#line 1895 "../../gcc/config/rx/rx.md"
(peep2_regno_dead_p (2, REGNO (operands[0])) && (optimize < 3 || optimize_size)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_74 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[1], E_QImode))
        return NULL;
      x4 = PATTERN (peep2_next_insn (1));
      switch (pattern41 (x4, 
E_QImode))
        {
        case 0:
          if (!
#line 1911 "../../gcc/config/rx/rx.md"
(REGNO (operands[0]) == REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[2])
       || peep2_regno_dead_p (2, REGNO (operands[0])))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_76 (insn, operands);

        case 1:
          if (!
#line 1926 "../../gcc/config/rx/rx.md"
(REGNO (operands[0]) == REGNO (operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_80 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
