/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!rx_restricted_mem_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_QImode:
      if (!rx_restricted_mem_operand (operands[2], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != MINUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != MINUS
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != GTU
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 16
      || GET_MODE (x9) != E_CCmode)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  if (!register_operand (operands[0], E_SImode)
      || pattern21 (x1) != 0)
    return -1;
  return 0;
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 16
      || GET_MODE (x6) != E_CCmode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 0);
  return pattern32 (x8); /* [-1, 1] */
}

int
pattern44 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[4] = x6;
  if (!rx_source_operand (operands[4], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[1] = x7;
  if (!nonmemory_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x3, 2);
  operands[2] = x8;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (!comparison_operator (x2, E_SImode))
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!rx_source_operand (operands[3], E_SImode))
    return -1;
  x5 = XEXP (x1, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      operands[1] = x2;
      *pnum_clobbers = 1;
      return 34; /* cstoresi4 */

    case ZERO_EXTRACT:
      if (pattern31 (x5) != 0)
        return -1;
      operands[4] = x2;
      *pnum_clobbers = 1;
      return 147; /* *insv_cond */

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 0
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != MINUS
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 0
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x8, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
      || GET_MODE (x3) != E_SImode)
    return -1;
  x11 = XEXP (x6, 1);
  operands[0] = x11;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 30; /* stack_push */
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case PLUS:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              if (GET_CODE (x4) == REG
                  && REGNO (x4) == 0)
                {
                  res = recog_9 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[1] = x4;
              if (pattern17 (x1) != 0)
                return -1;
              x5 = XEXP (x3, 1);
              switch (GET_CODE (x5))
                {
                case ZERO_EXTEND:
                  switch (pattern45 (x3))
                    {
                    case 0:
                      if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                        return -1;
                      return 89; /* plussi3_zero_extendhi */

                    case 1:
                      if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                        return -1;
                      return 97; /* plussi3_zero_extendqi */

                    default:
                      return -1;
                    }

                case SIGN_EXTEND:
                  switch (pattern45 (x3))
                    {
                    case 0:
                      if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                        return -1;
                      return 93; /* plussi3_sign_extendhi */

                    case 1:
                      if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                        return -1;
                      return 101; /* plussi3_sign_extendqi */

                    default:
                      return -1;
                    }

                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case MEM:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[2] = x5;
                  if (!rx_source_operand (operands[2], E_SFmode)
                      || !register_operand (operands[0], E_SFmode)
                      || GET_MODE (x3) != E_SFmode
                      || !register_operand (operands[1], E_SFmode)
                      || !
#line 1947 "../../gcc/config/rx/rx.md"
(ALLOW_RX_FPU_INSNS))
                    return -1;
                  return 133; /* addsf3 */

                default:
                  return -1;
                }

            case PLUS:
              if (GET_MODE (x4) != E_SImode)
                return -1;
              x6 = XEXP (x4, 0);
              if (GET_CODE (x6) != LTU
                  || GET_MODE (x6) != E_SImode)
                return -1;
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 16
                  || GET_MODE (x7) != E_CCmode)
                return -1;
              x8 = XEXP (x6, 1);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x9 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x9) != CLOBBER
                  || pattern46 (x1, 
E_CCmode, 
16) != 0)
                return -1;
              x10 = XEXP (x4, 1);
              operands[1] = x10;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x5 = XEXP (x3, 1);
              operands[2] = x5;
              if (!rx_source_operand (operands[2], E_SImode)
                  || !
#line 950 "../../gcc/config/rx/rx.md"
(reload_completed))
                return -1;
              return 44; /* adc_internal */

            default:
              return -1;
            }

        case CALL:
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_QImode)
            return -1;
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x11 = XEXP (x2, 0);
          operands[0] = x11;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          x9 = XVECEXP (x1, 0, 1);
          switch (pattern34 (x9))
            {
            case 0:
              if (!rx_call_operand (operands[1], E_SImode))
                return -1;
              return 19; /* call_value_internal */

            case 1:
              if (!rx_symbolic_call_operand (operands[1], E_SImode))
                return -1;
              return 21; /* sibcall_value_internal */

            default:
              return -1;
            }

        case MINUS:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              if (GET_CODE (x4) == REG
                  && REGNO (x4) == 0
                  && GET_MODE (x4) == E_SImode)
                {
                  res = recog_10 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              x11 = XEXP (x2, 0);
              operands[0] = x11;
              x5 = XEXP (x3, 1);
              switch (GET_CODE (x5))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case MEM:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  x9 = XVECEXP (x1, 0, 1);
                  switch (GET_CODE (x9))
                    {
                    case SET:
                      if (pnum_clobbers == NULL)
                        return -1;
                      x12 = XEXP (x9, 1);
                      if (GET_CODE (x12) != MINUS
                          || GET_MODE (x12) != E_SImode
                          || pattern43 (x12, 
GTU) != 0
                          || !register_operand (operands[0], E_SImode)
                          || GET_MODE (x3) != E_SImode
                          || pattern21 (x1) != 0)
                        return -1;
                      *pnum_clobbers = 1;
                      return 86; /* subdi3_internal */

                    case CLOBBER:
                      x13 = XEXP (x9, 0);
                      if (GET_CODE (x13) != REG
                          || REGNO (x13) != 16
                          || GET_MODE (x13) != E_CCmode
                          || !register_operand (operands[0], E_SFmode)
                          || GET_MODE (x3) != E_SFmode)
                        return -1;
                      operands[1] = x4;
                      if (!register_operand (operands[1], E_SFmode))
                        return -1;
                      operands[2] = x5;
                      if (!rx_source_operand (operands[2], E_SFmode)
                          || !
#line 1980 "../../gcc/config/rx/rx.md"
(ALLOW_RX_FPU_INSNS))
                        return -1;
                      return 136; /* subsf3 */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  switch (pattern33 (x1))
                    {
                    case 0:
                      if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                        return -1;
                      return 107; /* minussi3_zero_extendhi */

                    case 1:
                      if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                        return -1;
                      return 113; /* minussi3_zero_extendqi */

                    default:
                      return -1;
                    }

                case SIGN_EXTEND:
                  switch (pattern33 (x1))
                    {
                    case 0:
                      if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                        return -1;
                      return 110; /* minussi3_sign_extendhi */

                    case 1:
                      if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                        return -1;
                      return 116; /* minussi3_sign_extendqi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case MINUS:
              if (pattern24 (x3, 
REG, 
GEU) != 0)
                return -1;
              x5 = XEXP (x3, 1);
              x14 = XEXP (x5, 0);
              if (REGNO (x14) != 16
                  || GET_MODE (x14) != E_CCmode)
                return -1;
              x15 = XEXP (x5, 1);
              if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x9 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x9) != CLOBBER
                  || pattern46 (x1, 
E_CCmode, 
16) != 0)
                return -1;
              x6 = XEXP (x4, 0);
              operands[1] = x6;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x4, 1);
              operands[2] = x10;
              if (!rx_compare_operand (operands[2], E_SImode)
                  || !
#line 1672 "../../gcc/config/rx/rx.md"
(reload_completed))
                return -1;
              return 84; /* sbb_internal */

            default:
              return -1;
            }

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          if (!comparison_operator (x3, E_SImode))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (pattern9 (x9, 
16, 
CLOBBER, 
E_CCmode) != 0)
            return -1;
          switch (pattern36 (x2))
            {
            case 0:
              return 34; /* cstoresi4 */

            case 1:
              return 147; /* *insv_cond */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XEXP (x3, 0);
          if (!comparison_operator (x4, E_VOIDmode))
            return -1;
          operands[5] = x4;
          x9 = XVECEXP (x1, 0, 1);
          if (pattern9 (x9, 
16, 
CLOBBER, 
E_CCmode) != 0
              || pattern44 (x2) != 0
              || !
#line 763 "../../gcc/config/rx/rx.md"
((CONSTANT_P (operands[1]) || CONSTANT_P (operands[2]))
    || (REG_P (operands[1]) && REG_P (operands[2]))))
            return -1;
          return 37; /* *movsicc */

        case ABS:
          if (pattern14 (x1) != 0)
            return -1;
          return 40; /* abssi2 */

        case COMPARE:
          return recog_13 (x1, insn, pnum_clobbers);

        case AND:
          switch (pattern16 (x1))
            {
            case 0:
              return 47; /* andsi3 */

            case 1:
              if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 90; /* andsi3_zero_extendhi */

            case 2:
              if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 98; /* andsi3_zero_extendqi */

            case 3:
              if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 94; /* andsi3_sign_extendhi */

            case 4:
              if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 102; /* andsi3_sign_extendqi */

            default:
              return -1;
            }

        case DIV:
          if (pattern17 (x1) != 0)
            return -1;
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[2] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern48 (x3, 
E_SImode) != 0)
                    return -1;
                  return 51; /* divsi3 */

                case E_SFmode:
                  if (pattern48 (x3, 
E_SFmode) != 0
                      || !
#line 1958 "../../gcc/config/rx/rx.md"
(ALLOW_RX_FPU_INSNS))
                    return -1;
                  return 134; /* divsf3 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern45 (x3))
                {
                case 0:
                  if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                    return -1;
                  return 105; /* divsi3_zero_extendhi */

                case 1:
                  if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                    return -1;
                  return 111; /* divsi3_zero_extendqi */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              switch (pattern45 (x3))
                {
                case 0:
                  if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                    return -1;
                  return 108; /* divsi3_sign_extendhi */

                case 1:
                  if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                    return -1;
                  return 114; /* divsi3_sign_extendqi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UDIV:
          switch (pattern16 (x1))
            {
            case 0:
              return 52; /* udivsi3 */

            case 1:
              if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 106; /* udivsi3_zero_extendhi */

            case 2:
              if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 112; /* udivsi3_zero_extendqi */

            case 3:
              if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 109; /* udivsi3_sign_extendhi */

            case 4:
              if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 115; /* udivsi3_sign_extendqi */

            default:
              return -1;
            }

        case NEG:
          if (pattern14 (x1) != 0)
            return -1;
          return 64; /* negsi2 */

        case NOT:
          if (pattern14 (x1) != 0)
            return -1;
          return 66; /* one_cmplsi2 */

        case IOR:
          switch (pattern16 (x1))
            {
            case 0:
              return 68; /* iorsi3 */

            case 1:
              if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 91; /* iorsi3_zero_extendhi */

            case 2:
              if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 99; /* iorsi3_zero_extendqi */

            case 3:
              if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 95; /* iorsi3_sign_extendhi */

            case 4:
              if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 103; /* iorsi3_sign_extendqi */

            default:
              return -1;
            }

        case ROTATE:
          if (pattern18 (x1) != 0)
            return -1;
          return 70; /* rotlsi3 */

        case ROTATERT:
          if (pattern18 (x1) != 0)
            return -1;
          return 72; /* rotrsi3 */

        case ASHIFT:
          if (pattern18 (x1) != 0)
            return -1;
          return 78; /* ashlsi3 */

        case SS_PLUS:
          if (pattern19 (x1, 
E_SImode) != 0)
            return -1;
          return 80; /* ssaddsi3 */

        case XOR:
          switch (pattern16 (x1))
            {
            case 0:
              return 87; /* xorsi3 */

            case 1:
              if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 92; /* xorsi3_zero_extendhi */

            case 2:
              if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 100; /* xorsi3_zero_extendqi */

            case 3:
              if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 96; /* xorsi3_sign_extendhi */

            case 4:
              if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 104; /* xorsi3_sign_extendqi */

            default:
              return -1;
            }

        case MULT:
          if (pattern19 (x1, 
E_SFmode) != 0
              || !
#line 1969 "../../gcc/config/rx/rx.md"
(ALLOW_RX_FPU_INSNS))
            return -1;
          return 135; /* mulsf3 */

        case FIX:
          if (pattern20 (x1, 
E_SFmode, 
E_SImode) != 0
              || !
#line 1990 "../../gcc/config/rx/rx.md"
(ALLOW_RX_FPU_INSNS))
            return -1;
          return 137; /* fix_truncsfsi2 */

        case FLOAT:
          if (pattern20 (x1, 
E_SImode, 
E_SFmode) != 0
              || !
#line 2000 "../../gcc/config/rx/rx.md"
(ALLOW_RX_FPU_INSNS))
            return -1;
          return 138; /* floatsisf2 */

        case ASHIFTRT:
        case LSHIFTRT:
          x9 = XVECEXP (x1, 0, 1);
          if (pattern9 (x9, 
16, 
CLOBBER, 
E_CCmode) != 0)
            return -1;
          x11 = XEXP (x2, 0);
          operands[0] = x11;
          if (register_operand (operands[0], E_SImode)
              && GET_MODE (x3) == E_SImode)
            {
              x4 = XEXP (x3, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_SImode))
                {
                  x5 = XEXP (x3, 1);
                  operands[2] = x5;
                  if (rx_shift_operand (operands[2], E_SImode))
                    {
                      switch (GET_CODE (x3))
                        {
                        case ASHIFTRT:
                          return 74; /* ashrsi3 */

                        case LSHIFTRT:
                          return 76; /* lshrsi3 */

                        default:
                          break;
                        }
                    }
                }
            }
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
              || pattern37 (x11) != 0)
            return -1;
          operands[3] = x3;
          if (!rshift_operator (operands[3], E_SImode))
            return -1;
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 149; /* *insv_cond_lt */

        case REG:
        case SUBREG:
        case MEM:
          switch (GET_CODE (x3))
            {
            case REG:
            case SUBREG:
              res = recog_11 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case MEM:
              res = recog_12 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[1] = x3;
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != SET)
            return -1;
          x11 = XEXP (x2, 0);
          operands[0] = x11;
          x12 = XEXP (x9, 1);
          operands[2] = x12;
          x13 = XEXP (x9, 0);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !rx_compare_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode))
                return -1;
              return 150; /* sync_lock_test_and_setsi */

            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || !rx_compare_operand (operands[1], E_QImode)
                  || !register_operand (operands[2], E_QImode))
                return -1;
              return 151; /* xchg_memqi */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || !rx_compare_operand (operands[1], E_HImode)
                  || !register_operand (operands[2], E_HImode))
                return -1;
              return 152; /* xchg_memhi */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 48
              || GET_MODE (x3) != E_SImode)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (pattern9 (x9, 
16, 
CLOBBER, 
E_CCmode) != 0)
            return -1;
          x11 = XEXP (x2, 0);
          operands[0] = x11;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x16 = XVECEXP (x3, 0, 0);
          operands[1] = x16;
          if (!rx_compare_operand (operands[1], E_SFmode))
            return -1;
          return 169; /* lrintsf2 */

        default:
          return -1;
        }

    case PARALLEL:
      if (XVECLEN (x2, 0) < 1)
        return -1;
      operands[1] = x2;
      if (!rx_rtsd_vector (operands[1], E_VOIDmode))
        return -1;
      x17 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x17) != SET)
        return -1;
      x18 = XEXP (x17, 1);
      if (GET_CODE (x18) != PLUS
          || GET_MODE (x18) != E_SImode)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != REG
          || REGNO (x19) != 0
          || GET_MODE (x19) != E_SImode)
        return -1;
      x20 = XEXP (x17, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 0
          || GET_MODE (x20) != E_SImode)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != RETURN)
        return -1;
      x21 = XEXP (x18, 1);
      operands[0] = x21;
      if (!const_int_operand (operands[0], E_SImode)
          || !
#line 386 "../../gcc/config/rx/rx.md"
(reload_completed))
        return -1;
      return 14; /* pop_and_return */

    case CALL:
      x11 = XEXP (x2, 0);
      if (GET_CODE (x11) != MEM
          || GET_MODE (x11) != E_QImode)
        return -1;
      x3 = XEXP (x2, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XEXP (x11, 0);
      operands[0] = x22;
      x9 = XVECEXP (x1, 0, 1);
      switch (pattern34 (x9))
        {
        case 0:
          if (!rx_call_operand (operands[0], E_SImode))
            return -1;
          return 18; /* call_internal */

        case 1:
          if (!rx_symbolic_call_operand (operands[0], E_SImode))
            return -1;
          return 20; /* sibcall_internal */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      x9 = XVECEXP (x1, 0, 1);
      if (pattern9 (x9, 
16, 
CLOBBER, 
E_CCmode) != 0
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          x17 = XVECEXP (x2, 0, 0);
          operands[0] = x17;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          switch (XINT (x2, 1))
            {
            case 31:
              return 170; /* clrpsw */

            case 50:
              return 171; /* setpsw */

            default:
              return -1;
            }

        case 2:
          if (XINT (x2, 1) != 43)
            return -1;
          x17 = XVECEXP (x2, 0, 0);
          operands[0] = x17;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x23 = XVECEXP (x2, 0, 1);
          operands[1] = x23;
          if (!nonmemory_operand (operands[1], E_SImode))
            return -1;
          return 173; /* mvtc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
