/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return pattern3 (x3, pnum_clobbers); /* [-1, 4] */

    case ASHIFT:
      x5 = XEXP (x4, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x4, 1);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || !rx_shift_operand (operands[1], E_SImode))
            return -1;
          return 5;

        case MEM:
          if (!rtx_equal_p (x7, operands[0])
              || !rx_restricted_mem_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || GET_MODE (x4) != E_QImode
              || !nonmemory_operand (operands[1], E_QImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern24 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i2
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern26 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], i1))
    return -1;
  x7 = XEXP (x5, 1);
  operands[1] = x7;
  if (!rx_source_operand (operands[1], i1))
    return -1;
  x8 = XEXP (x2, 1);
  operands[2] = x8;
  if (!label_ref_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern37 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != ZERO_EXTRACT
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x1, 2);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern46 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != E_SImode)
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (!register_operand (x4, E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  if (!rx_source_operand (x5, E_SImode))
    return -1;
  x6 = XEXP (x2, 2);
  switch (GET_CODE (x6))
    {
    case PC:
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC)
        return -1;
      operands[3] = x3;
      operands[0] = x4;
      operands[1] = x5;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      if (!label_ref_operand (operands[2], E_VOIDmode))
        return -1;
      return 1; /* *cbranchsi4 */

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      if (pnum_clobbers == NULL)
        return -1;
      operands[2] = x6;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      operands[5] = x3;
      operands[3] = x4;
      operands[4] = x5;
      x8 = XEXP (x2, 1);
      operands[1] = x8;
      if (!nonmemory_operand (operands[1], E_SImode)
          || !
#line 763 "../../gcc/config/rx/rx.md"
((CONSTANT_P (operands[1]) || CONSTANT_P (operands[2]))
    || (REG_P (operands[1]) && REG_P (operands[2]))))
        return -1;
      *pnum_clobbers = 1;
      return 37; /* *movsicc */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 16)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x3, 0);
  if (GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x6, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x9 = XEXP (x6, 1);
  if (GET_MODE (x9) != E_SImode)
    return -1;
  switch (GET_CODE (x7))
    {
    case ABS:
      if (GET_CODE (x9) != ABS)
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x9, 0);
      if (!rtx_equal_p (x11, operands[1])
          || !
#line 859 "../../gcc/config/rx/rx.md"
(reload_completed && rx_match_ccmode (insn, CC_ZSmode)))
        return -1;
      return 41; /* *abssi2_flags */

    case PLUS:
      if (GET_CODE (x9) != PLUS)
        return -1;
      x12 = XEXP (x7, 1);
      operands[2] = x12;
      if (!rx_source_operand (operands[2], E_SImode))
        return -1;
      x13 = XEXP (x9, 1);
      if (!rtx_equal_p (x13, operands[2]))
        return -1;
      x10 = XEXP (x7, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[1] = x10;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x9, 0);
          if (!rtx_equal_p (x11, operands[1])
              || !
#line 911 "../../gcc/config/rx/rx.md"
(reload_completed && rx_match_ccmode (insn, CC_ZSCmode)))
            return -1;
          return 43; /* *addsi3_flags */

        case PLUS:
          if (GET_MODE (x10) != E_SImode)
            return -1;
          x14 = XEXP (x10, 0);
          if (GET_CODE (x14) != LTU
              || GET_MODE (x14) != E_SImode)
            return -1;
          x15 = XEXP (x14, 0);
          if (GET_CODE (x15) != REG
              || REGNO (x15) != 16
              || GET_MODE (x15) != E_CCmode)
            return -1;
          x16 = XEXP (x14, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x11 = XEXP (x9, 0);
          if (GET_CODE (x11) != PLUS
              || GET_MODE (x11) != E_SImode)
            return -1;
          x17 = XEXP (x11, 0);
          if (GET_CODE (x17) != LTU
              || GET_MODE (x17) != E_SImode)
            return -1;
          x18 = XEXP (x17, 0);
          if (GET_CODE (x18) != REG
              || REGNO (x18) != 16
              || GET_MODE (x18) != E_CCmode)
            return -1;
          x19 = XEXP (x17, 1);
          if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x20 = XEXP (x10, 1);
          operands[1] = x20;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x21 = XEXP (x11, 1);
          if (!rtx_equal_p (x21, operands[1])
              || !
#line 971 "../../gcc/config/rx/rx.md"
(reload_completed && rx_match_ccmode (insn, CC_ZSCmode)))
            return -1;
          return 45; /* *adc_flags */

        default:
          return -1;
        }

    case AND:
      if (GET_CODE (x9) != AND
          || pattern49 (x1) != 0
          || !
#line 1139 "../../gcc/config/rx/rx.md"
(reload_completed && rx_match_ccmode (insn, CC_ZSmode)))
        return -1;
      return 48; /* *andsi3_flags */

    case NEG:
      if (GET_CODE (x9) != NEG)
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x9, 0);
      if (!rtx_equal_p (x11, operands[1])
          || !
#line 1370 "../../gcc/config/rx/rx.md"
(reload_completed && rx_match_ccmode (insn, CC_ZSmode)))
        return -1;
      return 65; /* *negsi2_flags */

    case NOT:
      if (GET_CODE (x9) != NOT)
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x9, 0);
      if (!rtx_equal_p (x11, operands[1])
          || !
#line 1394 "../../gcc/config/rx/rx.md"
(reload_completed && rx_match_ccmode (insn, CC_ZSmode)))
        return -1;
      return 67; /* *one_cmplsi2_flags */

    case IOR:
      if (GET_CODE (x9) != IOR
          || pattern49 (x1) != 0
          || !
#line 1443 "../../gcc/config/rx/rx.md"
(reload_completed && rx_match_ccmode (insn, CC_ZSmode)))
        return -1;
      return 69; /* *iorsi3_flags */

    case ROTATE:
      if (pattern47 (x1, 
ROTATE) != 0
          || !
#line 1475 "../../gcc/config/rx/rx.md"
(reload_completed && rx_match_ccmode (insn, CC_ZSmode)))
        return -1;
      return 71; /* *rotlsi3_flags */

    case ROTATERT:
      if (pattern47 (x1, 
ROTATERT) != 0
          || !
#line 1497 "../../gcc/config/rx/rx.md"
(reload_completed && rx_match_ccmode (insn, CC_ZSmode)))
        return -1;
      return 73; /* *rotrsi3_flags */

    case ASHIFTRT:
      if (pattern47 (x1, 
ASHIFTRT) != 0
          || !
#line 1522 "../../gcc/config/rx/rx.md"
(reload_completed && rx_match_ccmode (insn, CC_ZSmode)))
        return -1;
      return 75; /* *ashrsi3_flags */

    case LSHIFTRT:
      if (pattern47 (x1, 
LSHIFTRT) != 0
          || !
#line 1550 "../../gcc/config/rx/rx.md"
(reload_completed && rx_match_ccmode (insn, CC_ZSmode)))
        return -1;
      return 77; /* *lshrsi3_flags */

    case ASHIFT:
      if (pattern47 (x1, 
ASHIFT) != 0
          || !
#line 1578 "../../gcc/config/rx/rx.md"
(reload_completed && rx_match_ccmode (insn, CC_ZSmode)))
        return -1;
      return 79; /* *ashlsi3_flags */

    case MINUS:
      if (GET_CODE (x9) != MINUS)
        return -1;
      x10 = XEXP (x7, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          if (pattern49 (x1) != 0
              || !
#line 1642 "../../gcc/config/rx/rx.md"
(reload_completed && rx_match_ccmode (insn, CC_ZSCmode)))
            return -1;
          return 83; /* *subsi3_flags */

        case MINUS:
          if (GET_MODE (x10) != E_SImode)
            return -1;
          x12 = XEXP (x7, 1);
          if (GET_CODE (x12) != GEU
              || GET_MODE (x12) != E_SImode)
            return -1;
          x22 = XEXP (x12, 0);
          if (GET_CODE (x22) != REG
              || REGNO (x22) != 16
              || GET_MODE (x22) != E_CCmode)
            return -1;
          x23 = XEXP (x12, 1);
          if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern43 (x9, 
GEU) != 0)
            return -1;
          x13 = XEXP (x9, 1);
          x24 = XEXP (x13, 0);
          if (GET_CODE (x24) != REG
              || REGNO (x24) != 16
              || GET_MODE (x24) != E_CCmode)
            return -1;
          x25 = XEXP (x13, 1);
          if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x14 = XEXP (x10, 0);
          operands[1] = x14;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x20 = XEXP (x10, 1);
          operands[2] = x20;
          if (!rx_compare_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x9, 0);
          x17 = XEXP (x11, 0);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          x21 = XEXP (x11, 1);
          if (!rtx_equal_p (x21, operands[2])
              || !
#line 1691 "../../gcc/config/rx/rx.md"
(reload_completed))
            return -1;
          return 85; /* *sbb_flags */

        default:
          return -1;
        }

    case XOR:
      if (GET_CODE (x9) != XOR
          || pattern49 (x1) != 0
          || !
#line 1772 "../../gcc/config/rx/rx.md"
(reload_completed && rx_match_ccmode (insn, CC_ZSmode)))
        return -1;
      return 88; /* *xorsi3_flags */

    default:
      return -1;
    }
}
