/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!rx_shift_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 16
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 1
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != USE)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 3
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != UNSPEC_VOLATILE
      || XVECLEN (x9, 0) != 3
      || XINT (x9, 1) != 21
      || GET_MODE (x9) != E_BLKmode)
    return -1;
  x10 = XVECEXP (x9, 0, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 1
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XVECEXP (x9, 0, 1);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 2
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x9, 0, 2);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != 3
      || GET_MODE (x12) != E_SImode)
    return -1;
  return 0;
}

int
pattern41 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  switch (GET_CODE (x2))
    {
    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[2] = x3;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[3] = x4;
      if (!register_operand (operands[3], i1))
        return -1;
      return 0;

    case SIGN_EXTEND:
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      if (!register_operand (operands[2], i1))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[0]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (rx_zs_comparison_operator (operands[3], E_VOIDmode)
      && pattern29 (x1, 
AND) == 0)
    {
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[0] = x5;
      if (register_operand (operands[0], E_SImode))
        {
          x6 = XEXP (x4, 1);
          operands[1] = x6;
          if (rx_source_operand (operands[1], E_SImode))
            {
              x7 = XEXP (x2, 1);
              operands[2] = x7;
              if (label_ref_operand (operands[2], E_VOIDmode))
                return 3; /* *cbranchsi4_tst */
            }
        }
    }
  if (!rx_z_comparison_operator (x3, E_VOIDmode))
    return -1;
  operands[2] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 16)
    return -1;
  x8 = XEXP (x1, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x7 = XEXP (x2, 1);
  operands[1] = x7;
  if (!immediate_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x2, 2);
  if (!rtx_equal_p (x9, operands[0])
      || !
#line 810 "../../gcc/config/rx/rx.md"
(reload_completed
   && ((GET_CODE (operands[2]) == EQ) || (GET_CODE (operands[2]) == NE))))
    return -1;
  return 38; /* *stcc */
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || GET_MODE (x4) != E_SImode)
    return -1;
  switch (REGNO (x4))
    {
    case 0:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != PLUS
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 0
          || GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
          || pattern46 (x1, 
E_SImode, 
0) != 0)
        return -1;
      return 32; /* stack_pop */

    case 2:
      if (pnum_clobbers == NULL
          || pattern38 (x1) != 0
          || GET_MODE (x3) != E_BLKmode
          || !
#line 2431 "../../gcc/config/rx/rx.md"
(rx_allow_string_insns))
        return -1;
      *pnum_clobbers = 3;
      return 153; /* rx_movstr */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 24
      || GET_MODE (x3) != E_SImode
      || pattern25 (x3) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != USE
      || pattern50 (x1) != 0)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 16
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x9 = XEXP (x4, 0);
  operands[1] = x9;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x10 = XEXP (x5, 0);
  operands[2] = x10;
  if (!memory_operand (operands[2], E_BLKmode)
      || !
#line 2592 "../../gcc/config/rx/rx.md"
(rx_allow_string_insns))
    return -1;
  return 157; /* rx_cmpstrn */
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      switch (GET_CODE (x2))
        {
        case IF_THEN_ELSE:
          x3 = XEXP (x2, 0);
          switch (GET_CODE (x3))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case LTGT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNEQ:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              operands[3] = x3;
              if (comparison_operator (operands[3], E_VOIDmode)
                  && pattern26 (x1, 
E_SImode) == 0
                  && 
#line 182 "../../gcc/config/rx/rx.md"
(reload_completed))
                return gen_split_1 (insn, operands);
              switch (GET_CODE (x3))
                {
                case NE:
                case EQ:
                case GE:
                case LT:
                case UNORDERED:
                case ORDERED:
                  x4 = XEXP (x3, 1);
                  if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    {
                      res = split_1 (x1, insn);
                      if (res != NULL_RTX)
                        return res;
                    }
                  operands[3] = x3;
                  if (!rx_fp_comparison_operator (operands[3], E_VOIDmode)
                      || pattern26 (x1, 
E_SFmode) != 0
                      || !(
#line 283 "../../gcc/config/rx/rx.md"
(ALLOW_RX_FPU_INSNS) && 
#line 285 "../../gcc/config/rx/rx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_4 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case NE:
        case EQ:
        case GE:
        case LT:
        case UNORDERED:
        case ORDERED:
          operands[1] = x2;
          if (!rx_fp_comparison_operator (operands[1], E_SImode))
            return NULL;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x3 = XEXP (x2, 0);
          operands[2] = x3;
          if (!register_operand (operands[2], E_SFmode))
            return NULL;
          x6 = XEXP (x2, 1);
          operands[3] = x6;
          if (!rx_source_operand (operands[3], E_SFmode)
              || !
#line 717 "../../gcc/config/rx/rx.md"
(reload_completed))
            return NULL;
          return gen_split_6 (insn, operands);

        case IOR:
          if (pattern8 (x1) != 0
              || !
#line 2024 "../../gcc/config/rx/rx.md"
( can_create_pseudo_p ()))
            return NULL;
          return gen_split_14 (insn, operands);

        case XOR:
          if (pattern8 (x1) != 0
              || !
#line 2053 "../../gcc/config/rx/rx.md"
( can_create_pseudo_p ()))
            return NULL;
          return gen_split_15 (insn, operands);

        case AND:
          if (GET_MODE (x2) != E_SImode)
            return NULL;
          x3 = XEXP (x2, 0);
          if (GET_CODE (x3) != NOT
              || GET_MODE (x3) != E_SImode)
            return NULL;
          x7 = XEXP (x3, 0);
          if (GET_CODE (x7) != ASHIFT
              || GET_MODE (x7) != E_SImode)
            return NULL;
          x8 = XEXP (x7, 0);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x9 = XEXP (x7, 1);
          operands[1] = x9;
          if (!rx_shift_operand (operands[1], E_SImode))
            return NULL;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 2084 "../../gcc/config/rx/rx.md"
( can_create_pseudo_p ()))
            return NULL;
          return gen_split_16 (insn, operands);

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x10 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x10) != SET)
            return NULL;
          x11 = XVECEXP (x1, 0, 1);
          if (pattern9 (x11, 
16, 
CLOBBER, 
E_CCmode) != 0)
            return NULL;
          x12 = XEXP (x10, 1);
          switch (GET_CODE (x12))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case LTGT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNEQ:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              if (!comparison_operator (x12, E_SImode))
                return NULL;
              switch (pattern36 (x10))
                {
                case 0:
                  if (!
#line 685 "../../gcc/config/rx/rx.md"
(reload_completed))
                    return NULL;
                  return gen_split_5 (insn, operands);

                case 1:
                  if (!
#line 2161 "../../gcc/config/rx/rx.md"
(reload_completed))
                    return NULL;
                  return gen_split_18 (insn, operands);

                default:
                  return NULL;
                }

            case IF_THEN_ELSE:
              if (GET_MODE (x12) != E_SImode)
                return NULL;
              x13 = XEXP (x12, 0);
              if (!comparison_operator (x13, E_VOIDmode))
                return NULL;
              operands[5] = x13;
              if (pattern44 (x10) != 0
                  || !(
#line 763 "../../gcc/config/rx/rx.md"
((CONSTANT_P (operands[1]) || CONSTANT_P (operands[2]))
    || (REG_P (operands[1]) && REG_P (operands[2]))) && 
#line 766 "../../gcc/config/rx/rx.md"
( reload_completed)))
                return NULL;
              return gen_split_7 (insn, operands);

            case AND:
              if (pattern35 (x10) != 0
                  || !
#line 1113 "../../gcc/config/rx/rx.md"
( RX_REG_P (operands[1]) && CONST_INT_P (operands[2])
   && pow2p_hwi (~UINTVAL (operands[2]))))
                return NULL;
              return gen_split_9 (insn, operands);

            case IOR:
              if (pattern35 (x10) != 0
                  || !
#line 1417 "../../gcc/config/rx/rx.md"
( RX_REG_P (operands[1]) && CONST_INT_P (operands[2])
   && pow2p_hwi (UINTVAL (operands[2]))))
                return NULL;
              return gen_split_10 (insn, operands);

            case SS_PLUS:
              if (pattern35 (x10) != 0
                  || !
#line 1594 "../../gcc/config/rx/rx.md"
(reload_completed))
                return NULL;
              return gen_split_11 (insn, operands);

            case XOR:
              if (pattern35 (x10) != 0
                  || !
#line 1745 "../../gcc/config/rx/rx.md"
( RX_REG_P (operands[1]) && CONST_INT_P (operands[2])
   && pow2p_hwi (UINTVAL (operands[2]))))
                return NULL;
              return gen_split_13 (insn, operands);

            case REG:
            case SUBREG:
              operands[2] = x12;
              if (!register_operand (operands[2], E_SImode))
                return NULL;
              x14 = XEXP (x10, 0);
              if (pattern37 (x14) != 0
                  || !
#line 2133 "../../gcc/config/rx/rx.md"
(reload_completed))
                return NULL;
              return gen_split_17 (insn, operands);

            case ASHIFTRT:
            case LSHIFTRT:
              operands[3] = x12;
              if (!rshift_operator (operands[3], E_SImode))
                return NULL;
              x15 = XEXP (x12, 1);
              if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
                return NULL;
              x14 = XEXP (x10, 0);
              if (pattern37 (x14) != 0)
                return NULL;
              x13 = XEXP (x12, 0);
              operands[2] = x13;
              if (!register_operand (operands[2], E_SImode))
                return NULL;
              return gen_split_19 (insn, operands);

            default:
              return NULL;
            }

        case 4:
          if (pattern7 (x1) != 0
              || !
#line 1043 "../../gcc/config/rx/rx.md"
(reload_completed))
            return NULL;
          return gen_split_8 (insn, operands);

        case 3:
          x10 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x10) != SET)
            return NULL;
          x12 = XEXP (x10, 1);
          if (GET_CODE (x12) != MINUS
              || pattern22 (x1) != 0
              || !
#line 1729 "../../gcc/config/rx/rx.md"
(reload_completed))
            return NULL;
          return gen_split_12 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
