/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ASHIFT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  if (!rx_shift_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 16
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return 0;
}

int
pattern20 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 16
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], i2))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!rx_compare_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[1] = x5;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[2] = x6;
  return 0;
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!rx_source_operand (operands[3], E_SImode))
    return -1;
  x5 = XEXP (x1, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      operands[1] = x2;
      return 0;

    case ZERO_EXTRACT:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x5, 2);
      operands[1] = x8;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      operands[4] = x2;
      return 1;

    default:
      return -1;
    }
}

int
pattern52 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i4)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i3)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i2
      || GET_MODE (x7) != i1)
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (comparison_operator (x3, E_VOIDmode))
        {
          res = recog_1 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case LT:
        case UNORDERED:
        case ORDERED:
          x4 = XEXP (x3, 1);
          if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (GET_CODE (x3))
                {
                case NE:
                case EQ:
                case GE:
                case LT:
                  res = recog_2 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                  break;

                default:
                  break;
                }
              if (rx_z_comparison_operator (x3, E_VOIDmode))
                {
                  operands[4] = x3;
                  if (pattern29 (x1, 
ZERO_EXTRACT) == 0
                      && pattern42 (x2) == 0)
                    return 4; /* *cbranchsi4_tst_ext */
                }
            }
          operands[3] = x3;
          if (rx_fp_comparison_operator (operands[3], E_VOIDmode)
              && pattern26 (x1, 
E_SFmode) == 0
              && 
#line 283 "../../gcc/config/rx/rx.md"
(ALLOW_RX_FPU_INSNS))
            return 6; /* *cbranchsf4 */
          break;

        default:
          break;
        }
      if (!comparison_operator (x3, E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 16)
        return -1;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) == LABEL_REF)
        {
          x7 = XEXP (x2, 2);
          if (GET_CODE (x7) == PC)
            {
              x8 = XEXP (x1, 0);
              if (GET_CODE (x8) == PC)
                {
                  operands[1] = x3;
                  x9 = XEXP (x6, 0);
                  operands[0] = x9;
                  if (
#line 313 "../../gcc/config/rx/rx.md"
(reload_completed))
                    return 8; /* *conditional_branch */
                }
            }
        }
      x8 = XEXP (x1, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      operands[2] = x3;
      operands[1] = x6;
      if (!nonmemory_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x2, 2);
      if (!rtx_equal_p (x7, operands[0])
          || !
#line 829 "../../gcc/config/rx/rx.md"
(reload_completed))
        return -1;
      return 39; /* *stcc_reg */

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != PC)
    return NULL;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return NULL;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_SImode)
    return NULL;
  if (GET_CODE (x6) == AND
      && rx_zs_comparison_operator (x5, E_VOIDmode))
    {
      operands[3] = x5;
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      if (register_operand (operands[0], E_SImode))
        {
          x8 = XEXP (x6, 1);
          operands[1] = x8;
          if (rx_source_operand (operands[1], E_SImode))
            {
              x9 = XEXP (x2, 1);
              operands[2] = x9;
              if (label_ref_operand (operands[2], E_VOIDmode)
                  && 
#line 212 "../../gcc/config/rx/rx.md"
(reload_completed))
                return gen_split_2 (insn, operands);
            }
        }
    }
  if (GET_CODE (x6) != ZERO_EXTRACT
      || !rx_z_comparison_operator (x5, E_VOIDmode))
    return NULL;
  operands[4] = x5;
  if (pattern42 (x2) != 0
      || !
#line 235 "../../gcc/config/rx/rx.md"
(reload_completed))
    return NULL;
  return gen_split_3 (insn, operands);
}
